# Listing 3. Fragmenty kodu odpowiadające za przygotowanie danych do wysyłki do serwisu Initial State

def streamTemp():
    streamer = Streamer(bucket_name=BUCKET_NAME,bucket_key=BUCKET_KEY,access_key=ACCESS_KEY)
    while True:
        tempC = readTemp()
        tempF = tempC * 9.0 / 5.0 + 32.0
        if tempF > TEMPERATURE_TOO_HIGH_F:
            streamer.log("Status", ":fire: :exclamation:")
        if tempF < TEMPERATURE_TOO_LOW_F:
            streamer.log("Status", ":snowflake: :exclamation:")
        streamer.log("Temperature(F)", tempF)
        streamer.flush()
        print "Temperature: " + str(tempF) + " F"
        time.sleep(TEMPERATURE_DELAY)

class EventProcessor:
    def __init__(self):
        self._measured = False
        self.done = False
        self._measureCnt = 0
        self._events = range(WEIGHT_SAMPLES)
        self.bottles = 0
        self._bottlesPrev = -1
        self._doorStatus = False
        self._takeMeasurement = False
        self.streamer = Streamer(bucket_name=BUCKET_NAME,bucket_key=BUCKET_KEY,access_key=ACCESS_KEY)

    def mass(self, event):
        # Take measurement ony when the door closes
        if (self._doorStatus == True and event.doorStatus == False):
            self._takeMeasurement = True
            self._measureCnt = 0
            self.streamer.log(":door: Door", "Closed")
            self.streamer.flush()
            print "Door Closed"
            print "Starting measurement ..."
            time.sleep(2) 
        # Door is opened, ensure no measurement is being taken
        if (self._doorStatus == False and event.doorStatus == True):
            self._takeMeasurement = False
            self.streamer.log(":door: Door", "Open")
            self.streamer.flush()
            print "Door Opened"
        if (self._takeMeasurement == True and event.totalWeight > 2):
            self._events[self._measureCnt] = event.totalWeight*2.20462
            self._measureCnt += 1
            if self._measureCnt == WEIGHT_SAMPLES:
                self._sum = 0
                for x in range(0, WEIGHT_SAMPLES-1):
                    self._sum += event.totalWeight*2.20462
                self._weight = self._sum/WEIGHT_SAMPLES
                self._weightBottles = self._weight - WEIGHT_BASE
                self.bottles = int(round(self._weightBottles / WEIGHT_BOTTLE))
                self._measureCnt = 0
                print str(self._weight) + " lbs total, " + str(self._weightBottles) + " lbs in bottles"
                if self.bottles < FRIDGE_EMPTY:
                    self.streamer.log("Status", ":scream: :exclamation:")
                elif self.bottles < FRIDGE_GETTING_LOW:
                    self.streamer.log("Status", ":worried: :exclamation:")
                else:    
                    self.streamer.log("Status", ":beers: :thumbsup:")
                self.streamer.flush()
                if (self.bottles != self._bottlesPrev) and (self.bottles >= 0):
                    self.streamer.log(":beer: Bottles Present", self.bottles)
                    self.streamer.flush()
                    if (self._bottlesPrev != -1) and (self._bottlesPrev > self.bottles):
                        for x in range(0, self._bottlesPrev-self.bottles):
                            print "Bottle removed"
                            self.streamer.log(":beers: Bottle Removed", ":beers:")
                            self.streamer.flush()
                    self._bottlesPrev = self.bottles
                print str(self.bottles) + " Bottles"
                print "Measurement complete!"
                self._takeMeasurement = False
            if not self._measured:
                self._measured = True
        self._doorStatus = event.doorStatus

    @property
    def weight(self):
        if not self._events:
            return 0
        histogram = collections.Counter(round(num, 1) for num in self._events)
        return histogram.most_common(1)[0][0]

class BoardEvent:
    def __init__(self, topLeft, topRight, bottomLeft, bottomRight, buttonPressed, buttonReleased):

        self.topLeft = topLeft
        self.topRight = topRight
        self.bottomLeft = bottomLeft
        self.bottomRight = bottomRight
        self.buttonPressed = buttonPressed
        self.buttonReleased = buttonReleased
        #convenience value
        self.totalWeight = topLeft + topRight + bottomLeft + bottomRight
        self.doorStatus = io.input(DOOR_PIN)

class Wiiboard:
    def createBoardEvent(self, bytes):
        buttonBytes = bytes[0:2]
        bytes = bytes[2:12]
        buttonPressed = False
        buttonReleased = False

        state = (int(buttonBytes[0].encode("hex"), 16) << 8) | int(buttonBytes[1].encode("hex"), 16)
        if state == BUTTON_DOWN_MASK:
            buttonPressed = True
            if not self.buttonDown:
                print "Button pressed"
                self.buttonDown = True

        if not buttonPressed:
            if self.lastEvent.buttonPressed:
                buttonReleased = True
                self.buttonDown = False
                print "Button released"

        rawTR = (int(bytes[0].encode("hex"), 16) << 8) + int(bytes[1].encode("hex"), 16)
        rawBR = (int(bytes[2].encode("hex"), 16) << 8) + int(bytes[3].encode("hex"), 16)
        rawTL = (int(bytes[4].encode("hex"), 16) << 8) + int(bytes[5].encode("hex"), 16)
        rawBL = (int(bytes[6].encode("hex"), 16) << 8) + int(bytes[7].encode("hex"), 16)

        topLeft = self.calcMass(rawTL, TOP_LEFT)
        topRight = self.calcMass(rawTR, TOP_RIGHT)
        bottomLeft = self.calcMass(rawBL, BOTTOM_LEFT)
        bottomRight = self.calcMass(rawBR, BOTTOM_RIGHT)
        boardEvent = BoardEvent(topLeft, topRight, bottomLeft, bottomRight, buttonPressed, buttonReleased)
        return boardEvent
